unit I2CCOM2;

interface
 uses  PORTINC, Windows;

Procedure I2C_Init;
Procedure Start;
Procedure Stop;
Procedure Acknowledge;
Procedure KeinAcknowledge;
Function Ausgeben (Wert : Byte): Boolean;
Function  Einlesen : Byte;


implementation

procedure I2C_Init;
begin
  OpenCom(Pchar('com2:9600,N,8,1'));
  RTS(1); DTR(1);          { SCL=1, SDA=1 }
end;

procedure Start;
begin
  DTR(0);          { SDA=0 }
  RTS(0);          { SCL=0 }
end;

procedure Stop;
begin
  RTS(0); DTR(0);  { SCL=0, SDA=0 }
  RTS(1);          { SCL=1 }
  DTR(1);          { SDA=1 }
end;

procedure Acknowledge;
begin
  RTS(0); DTR(0);  { SCL=0, SDA=0 }
  RTS(1);          { SCL=1 }
  Delayus (10);    { Warteschleife }
  RTS(0);          { SCL=0 }
end;

procedure KeinAcknowledge;
begin
  RTS(0); DTR(1);  { SCL=0, SDA=1 }
  RTS(1);          { SCL=1 }
  Delayus (10);    { Warteschleife }
  RTS(0);          { SCL=0 }
end;

Function Ausgeben (Wert : Byte): Boolean;
var Bitwert, n: Byte;
begin
  Ausgeben := true;
  Bitwert := 128;
  for n:= 1 to 8 do begin
    if (Wert and Bitwert) = Bitwert then DTR(1)
     else DTR(0);   { SDA setzen }
    RTS(1);         { SCL=1 }
    Delayus (10);   { Warteschleife }
    RTS(0);         { SCL=0 }
    Bitwert := Bitwert div 2;
  end;
  DTR(1);           { SDA=1 }
  RTS(1);           { SCL=1, SDA lesen }
  Delayus (10);     { Warteschleife }
  if CTS = 1 then Ausgeben := False;
  RTS(0);           { SCL=0 }
end;

function Einlesen : Byte;
var Bitwert, Wert, n: Byte;
begin
  RTS(0); DTR(1);   { SDA=1, SCL=0 }
  Bitwert := 128;
  Wert := 0;
  for n:= 1 to 8 do begin
    RTS(1);         { SCL=1, SDA lesen }
    Delayus (10);   { Warteschleife }
    If CTS = 1 then Wert := Wert + Bitwert;
    RTS(0);         { SCL=0 }
    Bitwert := Bitwert div 2;
  end;
  Einlesen := Wert;
end;

end.
